import java.util.Random;

public class Main {

    private static final int N = 100;

    public static void main(String[] args) {
	AVLTree<Integer> tree = new AVLTree<Integer>();
        Random r = new Random();
	int    x;
	int    n;
	int    ir;
	Integer[]  feld;
	boolean[]  test = new boolean[N];

	n = Integer.parseInt(args[0]);
	
	ir = 0;				// n Zufallszahlen zwischen 0 und N-1 erzeugen und
	while (ir<n) {			// in den AVL-Baum einfuegen
	    x = r.nextInt(100);		// keine Zahlen mehrfach erzeugen!
	    if (!test[x]) {
	        test[x] = true;
	        tree.insert(x);
	        System.out.print(" "+x);
	        ir++;
	    }
	}
	System.out.println();

	tree.printTree();

        feld = new Integer[n];		// Sortierung ausgeben
        tree.sortedArray(feld);
        for (int i=0 ; i<n ; i++) {
	    System.out.print(" "+feld[i]);
	}
	System.out.println();
    }
}
